st7/

;*******************************************************************************
;	DEMO.ASM
;*******************************************************************************
;	SofTec Microsystems 2001
;*******************************************************************************
; File modificato da E.Marinoni
; 	Questo file  derivato dal file DEMO.ASM di SOFTEC.
;	Il pulsante viene gestito sotto Interrupt.
;
;	This program performs a general test of the IDB-ST7C254 demo board. Before
;	to run the program, make sure that all of the "LED ENABLE", "POTENTIOMETER
;	ENABLE", "SW ENABLE" and "PC4 ENABLE" jumpers are inserted.
;	When the program is running:
;	1. The dip-switch status is displayed on the LEDs;
;	2. When the PC4 push button is pressed, the value read from the
;	   potentiometer is displayed on the LEDs.
;*******************************************************************************

	TITLE	"DEMO.ASM"
	MOTOROLA
	#INCLUDE "st72254.inc"		; ST72C254 registers and memory mapping file
 
;*******************************************************************************
;	Local variables declaration
;*******************************************************************************
		
	BYTES
	segment 'ram0'

.DUMMY	DS.B	1

;*******************************************************************************
;	Program entry
;*******************************************************************************

	WORDS
	segment 'rom'  
		
.main
	call	init			; port initialization
	rim				; enables interrupts
.main10                                  

; Abilitando queste tre righe sotto e disabilitando gli Interrupt il
; programma funziona sempre e anche meglio perch non resta in
; interrupt continuo
;	btjt	PCDR, #4, main20	; dip-switch test se NON 
					; premuto va a main20
;	call	t_adc			; A/D test
;	jra	main10
.main20

	callr	t_switch
	jra		main10

;*******************************************************************************
;	A/D test
;*******************************************************************************
;	Reads the A/D channel connected to the potentiometer and displays the
;	result on the LEDs, in a bar-like way
;*******************************************************************************

.t_adc
	btjf	ADCCSR, #7, *
	ld		A, ADCDR
	clr		X
.t_adc10
	sub		A, #$1F
	jrc		t_adc20
	scf	
	rlc		X
	jra		t_adc10
.t_adc20	
	ld		PADR,X

	ret             ; Mettere BP

;*******************************************************************************
;	Dip switch test
;*******************************************************************************

.t_switch	
	ld		A, PBDR
	and		A, $0F
	ld		DUMMY, A
	ld		A, PCDR
	and		A, $0F
	swap		A
	or		A, DUMMY
	ld		PADR,A
	ret	        ; Mettere BP

;*******************************************************************************
;	Port initialization
;*******************************************************************************

.init	
	ld		A, #$FF
	ld		PADDR, A	; configures port A as output
	ld		PAOR, A 
	ld		A, #$25		; enables the A/D peripheral on PC5
	ld		ADCCSR, A

		; ********** Port C Setup Code
		
		ld a, #$C0	; Bit On = Output, Bit Off = Input
		ld PCDDR, a	; Port C Direction Register
		ld a, #$10	; 
		ld PCOR, a	; Port C Option Registerr	

		; ********* Control Registers

		ld a, #$00	; Con questo va perch Inter  F.E. e LowLevel e quindi
				; resto in Inter continuato e vedo i led accesi
;		ld a, #$90	; Con questa non va il mio programma perch Inter  solo F.E.
				; e i led NON si fa in tempo a vederli accendere
		ld MISCR1, a	; Normal Mode : Fcpu = 8000000Hz

		ld a, #$00	; Clock Filter Interrupt Disabled
		ld CRSR, a	

		ld a, #$7F	; Watchdog Control Register
		ld WDGCR, a	; Watchdog Disabled 		


	ret

;*******************************************************************************

int_catch	iret
                          
int_B_C		nop
		nop
		nop  
	call	t_adc			; A/D test e visualizzazione LED
		
		iret
int_A_C		iret
                          
;*******************************************************************************

	segment 'vectit'

	DC.W	int_catch		; FFE0-FFE1h location	NOT USED
	DC.W	int_catch		; FFE2-FFE3h location	NOT USED
	DC.W	int_catch		; FFE4-FFE5h location	I2C periph Int I2C
	DC.W	int_catch		; FFE6-FFE7h location	NOT USED
	DC.W	int_catch		; FFE8-FFE9h location	NOT USED
	DC.W	int_catch		; FFEA-FFEBh location	NOT USED
	DC.W	int_catch		; FFEC-FFEDh location	NOT USED
	DC.W	int_catch		; FFEE-FFEFh location	TimerB periph Int TIMER B
	DC.W	int_catch		; FFF0-FFF1h location   NOT USED
	DC.W	int_catch		; FFF2-FFF3h location   TimerA periph Int TIMER A
	DC.W	int_catch		; FFF4-FFF5h location   SPI periph Int SPI
	DC.W	int_catch		; FFF6-FFF7h location   ClockFilterInt CSS
	DC.W	int_B_C			; FFF8-FFF9h location   ExtInt PortB EI1 (anche Port C)
	DC.W	int_A_C			; FFFA-FFFBh location	ExtInt PortA EI0 (anche Port C)
	DC.W	int_catch		; FFFC-FFFDh location	SoftInt TRAP
	DC.W	main			; FFFE-FFFFh location	RESET

	END
