st7/

;************************************************************************ 
; TITLE:                ST72254.ASM
; DESCRIPTION:          ST72254 Register and memory mapping 
;
;************************************************************************

	BYTES           ; following addresses are 8 bit length
;********************************************************************
	segment byte at 0-71 'periph'
;********************************************************************

;**********************************************************************
;						I/O Ports registers
;**********************************************************************
.PCDR   DS.B    1       ; port C data register
.PCDDR  DS.B    1       ; port C data direction register
.PCOR   DS.B    1       ; port C option register
        DS.B    1       ; not used
        
.PBDR   DS.B    1       ; port B data register
.PBDDR  DS.B    1       ; port B data direction register
.PBOR   DS.B    1       ; port B option register
        DS.B    1       ; not used

.PADR   DS.B    1       ; port A data register
.PADDR  DS.B    1       ; port A data direction register
.PAOR   DS.B    1       ; port A option register

        DS.B    1       ; not used
        
reserved0    DS.B    20          ; unused

;**********************************************************************
;                        Miscellaneous register 1
;********************************************************************** 
.MISCR1  DS.B    1       ; miscellaneous register 1

;**********************************************************************
;                        SPI  registers
;**********************************************************************
.SPIDR  DS.B    1       ; SPI data register
.SPICR  DS.B    1       ; SPI control register
.SPISR  DS.B    1       ; SPI status register

;**********************************************************************
;                        Watchdog register
;**********************************************************************
.WDGCR   DS.B    1       ; watchdog register

;**********************************************************************
;                        Clock Reset Module register
;**********************************************************************
.CRSR     DS.B   1      ; Clock Reset  Control/status register
reserved1 DS.B   2      ;  unused

;**********************************************************************
;                        I2C registers
;**********************************************************************
.I2CCR   DS.B   1       ; i2c control register
.I2CSR1  DS.B   1       ; i2c status register 1
.I2CSR2  DS.B   1       ; i2c status register 2
.I2CCCR  DS.B   1       ; i2c clock control register 
.I2COAR1 DS.B   1       ; i2c own add register 1
.I2COAR2 DS.B   1       ; i2c own add register 2
.I2CDR   DS.B   1       ; i2c data register 

reserved3 DS.B  2       ; unused

;**********************************************************************
;                        timer A registers
;********************************************************************** 
.TACR2   DS.B    1       ; timer A control register 2
.TACR1   DS.B    1       ; timer A control register 1
.TASR    DS.B    1       ; timer status register
.TAIC1HR DS.B    1       ; timer A input capture 1 high register 
.TAIC1LR DS.B    1       ; timer A input capture 1 low register
.TAOC1HR DS.B    1       ; timer A output compare 1 high register
.TAOC1LR DS.B    1       ; timer A output compare 1 low register
.TACHR   DS.B    1       ; timer A counter high register
.TACLR   DS.B    1       ; timer A counter low register
.TAACHR  DS.B    1       ; timer A alternate counter high register
.TAACLR  DS.B    1       ; timer A alternate counter low register
.TAIC2HR DS.B    1       ; timer A input capture 2 high register 
.TAIC2LR DS.B    1       ; timer A input capture 2 low register
.TAOC2HR DS.B    1       ; timer A output compare 2 high register
.TAOC2LR DS.B    1       ; timer A output compare 2 low register

 
;**********************************************************************
;                        Miscellaneous register 2
;**********************************************************************
.MISCR2  DS.B    1       ; miscellaneous register 2

;**********************************************************************
;                        timer B registers
;**********************************************************************
.TBCR2   DS.B    1       ; timer B control register 2
.TBCR1   DS.B    1       ; timer B control register 1
.TBSR    DS.B    1       ; timer B status register
.TBIC1HR DS.B    1       ; timer B input capture 1 high register 
.TBIC1LR DS.B    1       ; timer B input capture 1 low register
.TBOC1HR DS.B    1       ; timer B output compare 1 high register
.TBOC1LR DS.B    1       ; timer B output compare 1 low register
.TBCHR   DS.B    1       ; timer B counter high register
.TBCLR   DS.B    1       ; timer B counter low register
.TBACHR  DS.B    1       ; timer B alternate counter high register
.TBACLR  DS.B    1       ; timer B alternate counter low register
.TBIC2HR DS.B    1       ; timer B input capture 2 high register 
.TBIC2LR DS.B    1       ; timer B input capture 2 low register
.TBOC2HR DS.B    1       ; timer B output compare 2 high register
.TBOC2LR DS.B    1       ; timer B output compare 2 low register
    
reserved5 DS.B  32       ; unused
    
;**********************************************************************
;                       ADC registers
;**********************************************************************
.ADCDR  DS.B    1       ; adc data register
.ADCCSR DS.B    1       ; adc control status register

   ; DS.B    14
   

;**********************************************************************
    segment byte at 80-FF 'ram0' ;Zero Page
;**********************************************************************
    WORDS           ; following addresses are 16 bit length

;**********************************************************************
    segment byte at 100-17F 'stack'
;**********************************************************************

;********************************************************************** 
    segment byte at E000-FFDF 'rom' 
;**********************************************************************

;**********************************************************************
    segment byte at FFE0-FFFF 'vectit'
;**********************************************************************

        end
        
        
